var chai = require('chai'),
    expect = chai.expect,
    temp = require('temp'),
    spawn = require('child_process').spawn,
    fs = require('fs'),
    support = require('../support');

describe('Exporting', function() {

    describe('Given I have a presentation', function() {

        var presentationPath = support.TEST + 'fixtures/presentations/valid';

        describe('When I export to a blank directory', function() {

            var exportPath,
                luxProcess;

            before(function(done) {
                exportPath = temp.mkdirSync();

                var command = support.ROOT + 'bin/lux';
                luxProcess = spawn(command, ['export', exportPath], {
                    cwd: presentationPath,
                    stdio: ['pipe', 'pipe', process.stderr]
                });
                console.log('bar');
                luxProcess.stdout.on('exit', function() {
                    console.log('foo');
                    done();
                });
            });

            it('should create a presentation html file', function() {
                expect(fs.readFileSync(exportPath + '/index.html')).toContain('<h1>Slide 1</h1>');
            });

        });

    });

});

